#ifndef Py_UFUNCOBJECT_H
#define Py_UFUNCOBJECT_H
#ifdef __cplusplus
extern "C" {
#endif

typedef void (VBinaryFunction) Py_FPROTO((char *, int, char *, int,
					  char *, int, int, void *));
typedef void (VUnaryFunction) Py_FPROTO((char *, int, char *, int, int, void *));

typedef void (*PyUFuncGenericFunction) Py_FPROTO((char **, int *, int *, void *));

typedef struct {
  PyObject_HEAD
    /* XXXX Add your own stuff here */
  int *ranks, *canonical_ranks;
  int nin, nout, nargs;
  int identity;
  PyUFuncGenericFunction *functions;
  void **data;
  int ntypes, nranks, attributes;
  char *name, *types;
  int check_return;
} PyUFuncObject;

extern DL_IMPORT(PyTypeObject) PyUFunc_Type;

#define PyUFunc_Unbounded 120
#define PyUFunc_One 1
#define PyUFunc_Zero 0
#define PyUFunc_None -1

PyObject *PyUFunc_FromFuncAndData(PyUFuncGenericFunction *func, void **data, char *types, int ntypes,
				  int nin, int nout, int identity, char *name, int check_return);
int PyUFunc_GenericFunction(PyUFuncObject *self, PyObject *args, PyArrayObject **mps);

extern void PyUFunc_f_f_As_d_d(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_d_d(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_F_F_As_D_D(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_D_D(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_O_O(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_ff_f_As_dd_d(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_dd_d(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_FF_F_As_DD_D(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_DD_D(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_OO_O(char **args, int *dimensions, int *steps, void *func);
extern void PyUFunc_O_O_method(char **args, int *dimensions, int *steps, void *func);

extern PyObject *PyArray_Map(PyObject *function, PyObject *args);

#ifdef __cplusplus
}
#endif
#endif /* !Py_UFUNCOBJECT_H */
